https://cn.vjudge.net/problem/HDU-3033

After months of hard working, Iserlohn finally wins awesome amount of scholarship. As a great zealot of sneakers, he decides to spend all his money on them in a sneaker store.


There are several brands of sneakers that Iserlohn wants to collect, such as Air Jordan and Nike Pro. And each brand has released various products. For the reason that Iserlohn is definitely a sneaker-mania, he desires to buy at least one product for each brand.
Although the fixed price of each product has been labeled, Iserlohn sets values for each of them based on his own tendency. With handsome but limited money, he wants to maximize the total value of the shoes he is going to buy. Obviously, as a collector, he won’t buy the same product twice.
Now, Iserlohn needs you to help him find the best solution of his problem, which means to maximize the total value of the products he can buy.

Input

Input contains multiple test cases. Each test case begins with three integers 1<=N<=100 representing the total number of products, 1 <= M<= 10000 the money Iserlohn gets, and 1<=K<=10 representing the sneaker brands. The following N lines each represents a product with three positive integers 1<=a<=k, b and c, 0<=b,c<100000, meaning the brand’s number it belongs, the labeled price, and the value of this product. Process to End Of File.

Output

For each test case, print an integer which is the maximum total value of the sneakers that Iserlohn purchases. Print "Impossible" if Iserlohn's demands can’t be satisfied.

Sample Input

5 10000 3
1 4 6
2 5 7
3 4 99
1 55 77
2 44 66

Sample Output

255

题意:一些鞋子有k种品牌,第k种牌子的鞋子里面有一些品种不同的鞋子,每种都有自己的价格和价值,收藏家有m元想收集每种品牌的鞋子至少一双(但是相同品牌相同品种的鞋他只要一双),问他总共可以收集多少价值的鞋子。

分析:有k个品牌,分组背包问题,《背包九讲》是每组最多选一件,这里不同,是选至少一件,我们对每组
进行01背包就行了.我们当前选第k组的时候在里面选择物品的时候是选的第几件.如果我们当前是选第k组中的第一件,那么是从第k-1组推过来的,如果不是取第一件(i),

那么就是第k组中的前一件(i-1)推过来的.

以下内容就是这题的精(da)华(keng)了:

但是这里有个非常重要的问题,我们写成要写成如下形式两个if不能调转:
if(dp[k][v-price[i]] != -1)
        dp[k][v] = max(dp[k][v] , dp[k][v - price[i]] + value[i]);
if(dp[k-1][v-price[i]] != -1 )
        dp[k][v] = max(dp[k][v] , dp[k-1][v-price[i]] + value[i]);
解释:顺序不能调转,因为如果代价为0,调转的话,有可能出现先有dp[k][v] = dp[k-1][v-0]+v,再有dp[k][v] =dp[k][v-0]+v = dp[k-1][v-0]+v+v,所以物品取了两次.
当然一种方便的解决办法是直接写个函数 a = max(a,b,c);
还有个重要的地方是初始化:如果我们一开始把dp初始化为0,则当所有鞋子的价值都是0时,我们就无法区分是买不全那几款鞋子还是能买全但最大价值是0

https://www.cnblogs.com/liyinggang/p/5402291.html

#include<bits/stdc++.h>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;
typedef long long ll;
int dp[105][10005]; 
int p[105],w[105],v[105];
int main(){
	int n,V,m;
	while(~scanf("%d%d%d",&n,&V,&m)){
		for(int i=1;i<=n;i++){
			scanf("%d%d%d",&p[i],&w[i],&v[i]);
		}
		memset(dp,-1,sizeof(dp));
		for(int i=0;i<=V;i++) dp[0][i]=0;
		for(int i=1;i<=m;i++){
			for(int j=1;j<=n;j++){
				if(p[j]==i){
					for(int k=V;k>=w[j];k--){
						if(dp[i][k-w[j]]!=-1){
							dp[i][k]=max(dp[i][k],dp[i][k-w[j]]+v[j]);
						}
						if(dp[i-1][k-w[j]]!=-1){
							dp[i][k]=max(dp[i][k],dp[i-1][k-w[j]]+v[j]);
						}
						
					}
				}
			}
		}
		if(dp[m][V]==-1) printf("Impossible\n");
		else printf("%d\n",dp[m][V]);
	}
	return 0;
}